import 'package:flutter/material.dart';
import 'package:sw_component/tool/ext_state.dart';

import 'box_card.dart';

class DataCard extends StatefulWidget {
  const DataCard([
    this.value = "",
    this.due = "",
    this.rate = "",
    this.status = "",
    this.onPressed,
    this.icon = Icons.arrow_forward_ios,
    this.textColor,
    this.backgroundColor,
    Key? key,
  ]) : super(key: key);

  const DataCard.named({
    this.value = "",
    this.due = "",
    this.rate = "",
    this.status = "",
    this.onPressed,
    this.icon = Icons.arrow_forward_ios,
    this.textColor,
    this.backgroundColor,
    Key? key,
  }) : super(key: key);

  final String value;
  final String due;
  final String rate;
  final String status;
  final Color? textColor;
  final Color? backgroundColor;
  final void Function()? onPressed;
  final IconData? icon;

  @override
  State<DataCard> createState() => _DataCardState();
}

class _DataCardState extends State<DataCard> {
  @override
  build(BuildContext context) => TextButton(
        onPressed: widget.onPressed,
        child: BoxCard(child: _buildContent()),
      );

  _buildContent() => Column(
        children: [
          Row(
            mainAxisAlignment: MainAxisAlignment.spaceBetween,
            children: [
              Flexible(
                flex: 2,
                child: Text(
                  widget.value,
                  style: TextStyle(
                    fontSize: 18,
                    color: colorScheme.onSurface,
                  ),
                ),
              ),
              Flexible(
                flex: 2,
                child: Column(
                  crossAxisAlignment: CrossAxisAlignment.start,
                  children: [
                    const Text(
                      'Due Date:',
                      style: TextStyle(
                        fontSize: 13,
                        color: Colors.grey,
                      ),
                    ),
                    const SizedBox(height: 8),
                    Text(
                      widget.due,
                      style: TextStyle(
                        fontSize: 13,
                        color: colorScheme.onSurface,
                      ),
                    ),
                  ],
                ),
              ),
              Flexible(
                flex: 1,
                child: widget.onPressed == null
                    ? const SizedBox(width: 18)
                    : Icon(
                        widget.icon,
                        size: 18,
                      ),
              ),
            ],
          ),
          Divider(
            color: isDark ? Colors.white30 : Colors.black26,
            height: 32,
          ),
          Row(
            mainAxisAlignment: MainAxisAlignment.spaceBetween,
            children: [
              Flexible(
                flex: 2,
                child: Column(
                  crossAxisAlignment: CrossAxisAlignment.start,
                  children: [
                    const Text(
                      'Interest Rate',
                      style: TextStyle(
                        fontSize: 13,
                        color: Colors.grey,
                      ),
                    ),
                    const SizedBox(height: 8),
                    Text(
                      widget.rate,
                      style: TextStyle(
                        fontSize: 13,
                        color: colorScheme.onSurface,
                      ),
                    ),
                    const SizedBox(width: 64),
                  ],
                ),
              ),
              Flexible(
                flex: 2,
                child: Column(
                  crossAxisAlignment: CrossAxisAlignment.start,
                  children: [
                    const Text('Status',
                        style: TextStyle(
                          fontSize: 13,
                          color: Colors.grey,
                        )),
                    const SizedBox(height: 8),
                    Text(
                      widget.status,
                      style: TextStyle(
                        fontSize: 13,
                        color: colorScheme.onSurface,
                      ),
                    ),
                  ],
                ),
              ),
              const Flexible(
                flex: 1,
                child: SizedBox(
                  width: 18,
                ),
              ),
            ],
          ),
        ],
      );
}
